﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;

namespace LifeGameScreenSaver
{
    public partial class LifeGameForm : Form
    {

        private World curWord;

        int ixStart;
        int iyStart;
        public LifeGameForm()
        {
            InitializeComponent();
            curWord = new World(1000, 1000);
            this.SetStyle( ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint, true);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Width = 5000;
            this.Height = 5000;

            this.Top = 0;
            this.Left = 0;
            foreach (Screen curScr in Screen.AllScreens)
            {
                if(curScr.Bounds.Left < Left)
                {
                    this.Left = curScr.Bounds.Left;
                }

                if (curScr.Bounds.Top < Left)
                {
                    this.Top = curScr.Bounds.Top;
                } 
            }
            this.Pb_Show.Image = curWord.GetWorldBitmap(5, Color.Green, Color.Black, this.Pb_Show.Width, this.Pb_Show.Height);
           
        }


        int refreshCount = 0;

        private void TimerRefresh_Tick(object sender, EventArgs e)
        {
            this.Pb_Show.Image = curWord.GetWorldBitmap(5, Color.Green, Color.Black,this.Pb_Show.Width ,this.Pb_Show.Height);
            curWord.RefreshWorld();

            if(refreshCount %10 ==0)
            {
                GC.Collect();
            }
        }
 
        private void Pb_Show_MouseMove(object sender, MouseEventArgs e)
        {
            if (ixStart == 0 && iyStart == 0)
            {
                ixStart = e.X;
                iyStart = e.Y;
                return;
            }
            //判断自屏幕保护程序运行后，鼠标的位置是否变动
            else if (e.X != ixStart || e.Y != iyStart)
            {
                Cursor.Show();
                Timer_Refresh.Enabled = false;
                Application.Exit();
            };
        }
    }
}
